<?php


if (IN_serendipity !== true) {
    die ("Don't hack!");
}

// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include dirname(__FILE__) . '/lang_en.inc.php';

// Subst Plugin for Serendipity
// 01/2006 by Thomas Nesges <thomas@tnt-computer.de>
//12/2006  Andy Hopkins Added Greybox functionality. <andy.hopkins@gmail.com>
class serendipity_event_lightbox extends serendipity_event {

    var $title = PLUGIN_EVENT_LIGHTBOX_NAME;
    
    // Remembers, if an image link was found in the article. If not found, nor CSS nor JS will be added to the blog header.
    var $foundImageLink = false;

    function introspect(&$propbag) {
        global $serendipity;

        $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_NAME);
        $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_DESC);
        $propbag->add('author',         'Thomas Nesges, Andy Hopkins, Lokesh Dhakar, Cody Lindley, Stephan Manske, Grischa Brockhaus');
        $propbag->add('version',        '1.6');
        $propbag->add('requirements',  array(
            'serendipity' => '0.9',
            'smarty'      => '2.6.7',
            'php'         => '4.1.0'
        ));
        $propbag->add('event_hooks',    array('frontend_display' => true, 'frontend_header' => true ));
        $propbag->add('stackable',      false);
        $propbag->add('groups',         array('IMAGES'));
        $propbag->add('cachable_events', array('frontend_display' => true));

        $this->markup_elements = array(
            array(
              'name'     => 'ENTRY_BODY',
              'element'  => 'body',
            ),
            array(
              'name'     => 'EXTENDED_BODY',
              'element'  => 'extended',
            ),
            array(
              'name'     => 'COMMENT',
              'element'  => 'comment',
            ),
            array(
              'name'     => 'HTML_NUGGET',
              'element'  => 'html_nugget',
            )
        );

        $conf_array = array();
        $conf_array[] = 'type';
        $conf_array[] = 'path';
        $conf_array[] = 'header_optimization';
        $conf_array[] = 'gallery_mode';
        $conf_array[] = 'entry_only';
        $conf_array[] = 'include_video';
        $conf_array[] = 'advanced_init_shadowbox';
        foreach($this->markup_elements as $element) {
            $conf_array[] = $element['name'];
        }

        $propbag->add('configuration', $conf_array);
    }


    function generate_content(&$title) {
        $title = PLUGIN_EVENT_LIGHTBOX_NAME;
    }


    function introspect_config_item($name, &$propbag) {
        global $serendipity;

        switch($name) {
            case 'type':
                $propbag->add('type',           'select');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_TYPE);
                $propbag->add('description',    '');
                $propbag->add('select_values',  array('lightbox2' => 'Lightbox 2 (v2.03.3)', 'lightbox' => 'Lightbox 1', 'lightbox_plus' => 'Lightbox plus', 'thickbox' => 'Thickbox (v3.1)', 'graybox'=> 'Greybox (v5.53)', 'shadowbox' => 'Shadowbox (v1.0)'));
                $propbag->add('default',        'lightbox');
                break;

            case 'path':
                $propbag->add('type',           'string');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_PATH);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_PATH_DESC);
                $propbag->add('default',        str_replace('//', '/', $serendipity['serendipityHTTPPath'] . preg_replace('@^.*(/plugins.*)@', '$1', dirname(__FILE__))));
                break;

            case 'header_optimization':
                $propbag->add('type',           'boolean');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_OPTIMIZATION);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_OPTIMIZATION_DESC);
                $propbag->add('default',        'false');
                break;

            case 'gallery_mode':
                $propbag->add('type',           'boolean');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_GALLERY);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_GALLERY_DESC);
                $propbag->add('default',        'false');
                break;
                
            case 'entry_only':
                $propbag->add('type',           'boolean');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_ENTRY_ONLY);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_ENTRY_ONLY_DESC);
                $propbag->add('default',        'true');
                break;

            case 'include_video':
                $propbag->add('type',           'boolean');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_VIDEO);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_VIDEO_DESC);
                $propbag->add('default',        'false');
                break;
          
            case 'advanced_init_shadowbox':
                $propbag->add('type',           'text');
                $propbag->add('name',           PLUGIN_EVENT_LIGHTBOX_INIT_SHADOWBOX);
                $propbag->add('description',    PLUGIN_EVENT_LIGHTBOX_INIT_SHADOWBOX_DESC);
                $propbag->add('default',        '{
flvPlayer:\'plugins/serendipity_event_lightbox/shadowbox/flvplayer.swf\',
loadingImage:\'plugins/serendipity_event_lightbox/shadowbox/images/loading.gif\'
}');
                break;

            default:
                $propbag->add('type',           'boolean');
                $propbag->add('name',           defined($name) ? constant($name) : $name);
                $propbag->add('description',    sprintf(APPLY_MARKUP_TO, defined($name) ? constant($name) : $name));
                $propbag->add('default',        'true');
                break;

        }
        return true;
    }

    function event_hook($event, &$bag, &$eventData) {
        global $serendipity;
        static $regex = null;
        static $sub   = null;
        static $subVideo = null;
        static $regexVideo = null;
        static $gallery_id = null;

        $hooks     = &$bag->get('event_hooks');

        if (isset($hooks[$event])) {

            $pluginDir = $this->get_config('path');
            $type      = $this->get_config('type');
            $gallery_mode = serendipity_db_bool($this->get_config('gallery_mode', false));
            
            // handle gallery_mode and the gallery_id
            $gallery_id = uniqid("");
            if (serendipity_db_bool($this->get_config('entry_only', true))) {
              if (isset($serendipity['GET']['id'])) {
                $gallery_id = $serendipity['GET']['id'];
              } else {
                $gallery_mode = false;
              }
            }             

            if ($regex == null) {
                if ($type == 'lightbox') {
                    $regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                    $sub   = '<a $1 rel=$3lightbox$3 $2';
                } elseif ($type == 'lightbox2') {
                  $regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                  if ($gallery_mode) {
                    $sub   = '<a $1 rel=$3lightbox['.$gallery_id.']$3 $2';
                  } else {
                    $sub   = '<a $1 rel=$3lightbox$3 $2';
                  }
                } elseif ($type == 'lightbox_plus') {
                  $regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                  if ($gallery_mode) {
                    $sub   = '<a $1 rel=$3lightbox'.$gallery_id.'$3 $2';
                  } else {
                    $sub   = '<a $1 rel=$3lightbox$3 $2';
                  }
                } elseif ($type == 'thickbox') {
					         $regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                   if ($gallery_mode) {
  					         $sub   = '<a class=$3thickbox$3 rel="'.$gallery_id.'" $1 $2';
                   } else {                   
  					         $sub   = '<a class=$3thickbox$3 $1 $2';
					         }                
                } elseif ($type == 'graybox') {
        					$regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                   if ($gallery_mode) {
  					         $sub   = '<a $1 rel=$3gb_imageset['.$gallery_id.']$3 $2';
                   } else {                   
  					         $sub   = '<a $1 rel=$3gb_image[]$3 $2';
					         }                
                } elseif ($type == 'shadowbox') {
                   $regex = '/<a([^>]+)(href=(["\'])[^"\']*\.(jpe?g|gif|png)["\'])/i';
                   $regexVideo = '/<a([^>]+)(href=(["\'])[^"\']*\.(flv|swf)["\'])/i';
                   if ($gallery_mode) {
                     $sub   = '<a $1 rel=$3shadowbox['.$gallery_id.']$3 $2';
                     $subVideo   = '<a $1 rel=$3shadowbox['.$gallery_id.'];height=400;width=600$3 $2';
                   } else {                   
                     $sub   = '<a $1 rel=$3shadowbox[]$3 $2';
					           $subVideo   = '<a $1 rel=$3shadowbox[];height=240;width=320$3 $2';
					         }
                }
            }


            switch($event) {
                case 'frontend_header':

                    // If no imagelink was processed, don't add css or js files to the header! (configurable optimization)
                    if (serendipity_db_bool($this->get_config('header_optimization', false)) && !$this->foundImageLink) {
                        return true;
                    }

                    // Lightbox Code http://www.huddletogether.com/projects/lightbox/
                    if ($type == 'lightbox') {
                        // lightbox_path is a workaround for the lightbox.js! pay attention when updating...
    					          echo '<script type="text/javascript">var lightbox_path = "' . $pluginDir . '/lightbox";</script>' . "\n";
                        echo '<script type="text/javascript" src="' . $pluginDir . '/lightbox/lightbox.js"></script>' . "\n";
                        echo '<link rel="stylesheet" type="text/css" href="' . $pluginDir.  '/lightbox/lightbox.css" />' . "\n";
                    } 
					// Lightbox Plus code http://serennz.sakura.ne.jp/toybox/lightbox/
					elseif ($type == 'lightbox_plus') {
					// updated on 06/03/2008 to version 20061027
					   // lightbox_path is a workaround for the lightbox.js! pay attention when updating...
		          echo '<script type="text/javascript">var lightbox_path = "'. $pluginDir . '/lightbox_plus";</script>' . "\n";
              echo '<script type="text/javascript" src="'. $pluginDir . '/lightbox_plus/spica.js"></script>' . "\n";
              echo '<script type="text/javascript" src="'. $pluginDir . '/lightbox_plus/lightbox_plus.js"></script>' . "\n";
              echo '<link rel="stylesheet" type="text/css" href="'. $pluginDir.  '/lightbox_plus/lightbox.css" />' . "\n";
          } 
					// Light Box 2 code http://www.huddletogether.com/projects/lightbox2/
					// updated to version 2.03.3 on 03/06/2008
					elseif ($type == 'lightbox2') {
					    // lightbox_path is a workaround for the lightbox.js! pay attention when updating...
    					echo '<script type="text/javascript">var lightbox_path = "' . $pluginDir . '/lightbox2";</script>' . "\n";
              echo '<script type="text/javascript" src="' . $pluginDir . '/lightbox2/js/prototype.js"></script>' . "\n";
              echo '<script type="text/javascript" src="' . $pluginDir . '/lightbox2/js/scriptaculous.js?load=effects"></script>' . "\n";
              echo '<script type="text/javascript" src="' . $pluginDir . '/lightbox2/js/lightbox.js"></script>' . "\n";
              echo '<link rel="stylesheet" type="text/css" href="' . $pluginDir.  '/lightbox2/css/lightbox.css" />' . "\n";
          } 
					// Thick Box code http://jquery.com/demo/thickbox/
					// updated to version 3.1 on 03/06/2008
					elseif ($type == 'thickbox') {
    			    echo '<link rel="stylesheet" type="text/css" href="' .$pluginDir . '/thickbox/thickbox.css" />' . "\n";
              echo '<script type="text/javascript" src="' .$pluginDir . '/thickbox/jquery.pack.js"></script>' . "\n";
    					echo '<script type="text/javascript" src="' .$pluginDir . '/thickbox/thickbox-compressed.js"></script>' . "\n";
                    }
					// Greybox Code http://orangoo.com/labs/GreyBox/
					// updated to v5.53 on 03/06/2008
					elseif ($type == 'graybox') {
    			  echo '<script type="text/javascript"> var GB_ROOT_DIR = "'.$pluginDir.'/greybox/";</script>' . "\n";
						echo '<link href="'.$pluginDir.'/greybox/gb_styles.css" rel="stylesheet" type="text/css"/>' . "\n";
						echo '<script type="text/javascript" src="'.$pluginDir.'/greybox/AJS.js"></script>' . "\n";
						echo '<script type="text/javascript" src="'.$pluginDir.'/greybox/AJS_fx.js"></script>';
						echo '<script type="text/javascript" src="'.$pluginDir.'/greybox/gb_scripts.js"></script>' . "\n";
					}
					// Shadowbox Code http://mjijackson.com/shadowbox/
					// added Version 1.0 on 03/06/2008
					elseif ($type == 'shadowbox') {
					  echo '<link rel="stylesheet" type="text/css" href="'.$pluginDir.'/shadowbox/src/css/shadowbox.css" />'. "\n";
            echo '<script type="text/javascript" src="'.$pluginDir.'/shadowbox/src/js/lib/yui-utilities.js"></script>'. "\n";
            echo '<script type="text/javascript" src="'.$pluginDir.'/shadowbox/src/js/adapter/shadowbox-yui.js"></script>'. "\n";
            echo '<script type="text/javascript" src="'.$pluginDir.'/shadowbox/src/js/shadowbox.js"></script>'. "\n";
            echo "<script type=\"text/javascript\"> YAHOO.util.Event.onDOMReady(function() {Shadowbox.init(".$this->get_config('advanced_init_shadowbox').");}); </script>";
          }
                    return true;
                    break;

                case 'frontend_display':
                    foreach ($this->markup_elements as $temp) {
                        if (isset($eventData[$temp['element']]) && serendipity_db_bool($this->get_config($temp['name'], true)) &&
                                !$eventData['properties']['ep_disable_markup_' . $this->instance] &&
                                !isset($serendipity['POST']['properties']['disable_markup_' . $this->instance])) {
                            $element = $temp['element'];

                            // preg_replace with replacement counter is available only from PHP 5.1 on
                            if (version_compare(PHP_VERSION, '5.1', '>=')) {
                                $replacement_count = 0;
                                $replacement_countVideo = 0;
                                $eventData[$element] = preg_replace($regex, $sub, $eventData[$element], -1,  $replacement_count);
                                if (($type == 'shadowbox') && (serendipity_db_bool($this->get_config('include_video', false))))
                                {
                                  $eventData[$element] = preg_replace($regexVideo, $subVideo, $eventData[$element], -1,  $replacement_countVideo);
                                }
                                
                                // Remember if an image link was found
                                if ($replacement_count>0) {
                                    $this->foundImageLink = true;
                                }
                            }
                            else {
                                $oldEventData = $eventData[$element];
                                $eventData[$element] = preg_replace($regex, $sub, $eventData[$element]);
                                if (($type == 'shadowbox') && (serendipity_db_bool($this->get_config('include_video', false))))
                                {
                                  $eventData[$element] = preg_replace($regexVideo, $subVideo, $eventData[$element]);
                                }
                                
                                // Remember if an image link was found by checking, if something was changed
                                if ($oldEventData!=$eventData[$element]) {
                                    $this->foundImageLink = true;
                                }
                            }
                        }
                    }
                    return true;
                    break;

              default:
                return false;
            }

        } else {
            return false;
        }
    }

    function install() {
        serendipity_plugin_api::hook_event('backend_cache_entries', $this->title);
    }

    function uninstall() {
        serendipity_plugin_api::hook_event('backend_cache_purge', $this->title);
        serendipity_plugin_api::hook_event('backend_cache_entries', $this->title);
    }
}
